#
#  Copyright (c) 1996, by Emanuel G. Noik
#
#  A very simple Tcl message service.
#
#  Allow many programs to talk to another through this central messaging
#  service.  Communication takes place through a two-way pipe.
#

#-------------------------------------------------------------------------------

proc Open {service} {
   global fdesc
   set fd [open "|$service" r+]
   set fdesc($fd) $service
   return $fd
}

#-------------------------------------------------------------------------------

proc Close {fd} {
   global fdesc
   Send $fd 
   unset fdesc($fd)
}

#-------------------------------------------------------------------------------

proc Send {fd msg} {
   puts $fd $msg
   flush $fd
}

#-------------------------------------------------------------------------------

proc Recv {fd} {
   gets $fd line
   return $line
}

#-------------------------------------------------------------------------------

proc Quit {} {
   global fdesc
   foreach fd [array names fdesc] {
      Close $fd
   }
   exit
}

#-------------------------------------------------------------------------------
