//------------------------------------------------------------------------------

inline int MapNormal( int min, int max, float x )
{
   return min + (int)( (float)( max - min ) * x + 0.5 );
}

//------------------------------------------------------------------------------

typedef enum
{
   PA_RelPosX,  PA_RelPosY,  PA_RelPosZ,
   PA_AbsPosX,  PA_AbsPosY,
   PA_AbsSizeX, PA_AbsSizeY,
   PA_RelSize,
   PA_RelSizeX, PA_RelSizeY,
   PA_LinkWidth,
   PA_HSVh, PA_HSVs, PA_HSVv,
   PA_FillPerc,
   PA_Label
}
PAttribute;

typedef struct {
   char* label;
   PAttribute attr;
} PAttrLabel;

extern PAttrLabel attributes[];

//------------------------------------------------------------------------------

class TkHInfo : public TclTkHInfo {
private:
   void		SetHSV( Vertex*, float, int );
   void		SetHSV( AArc*, float, int );
   void		LinkVariables( void );
   void		SetSize( HGContainer* );

   void		SetState( int type, int h, int b, int state, float x );
   void		SetState( int type, HGObject* o, int state, int on );

   int		Selects( int type, int h, HGObject* o );
   void		MaskOne( int type, int h, int b, int on, int newState );

   void		Translate( HGContainer* c, MN_Point* d );
   void		Scale( HGContainer* c, MN_Point* s );

public:
		TkHInfo( const char* id, Tcl_Interp* interp )
		: TclTkHInfo( id, interp ) {};
   virtual	~TkHInfo( void ) {};

   // Standard HGInfo methods.
   //
   virtual int	DumpBB( HGContainer*, const char*, int, int );
   virtual int	DumpGC( HGContainer*, const char*, int, int, int );
   virtual int	DumpMP( HGContainerArc*, const char*, int );

   // Dynamic query methods.
   //
   void		Paint( int type, int h, int b, int on );
   void		Link( int type, HGObject* o, int on );
   void		Mask( int type, int h, int b, int mode );

   int		UpdateHist( int type, int i, int w, int h, int n );

   // Dynamic mapping methods.
   //
   int		MapAttr( int type, int indx, PAttribute attr, char* alabel );

   // Additional methods.
   //
   void		Move( Vertex* v, MN_Point* d );
   void		Move( Vertex* v );
   void		Move( Blob* b );
   void		Redisplay( HGContainer* c );
   void		Scale( MN_Point* p );
};

//------------------------------------------------------------------------------

extern TkHInfo* TkAddH( const char* id, Tcl_Interp* interp );

//------------------------------------------------------------------------------
